﻿/*
 * Creado por SharpDevelop.
 * Usuario: Jorge
 * Fecha: 22/04/2013
 * Hora: 18:06
 * 
 * Para cambiar esta plantilla use Herramientas | Opciones | Codificación | Editar Encabezados Estándar
 */
using System;
using System.Linq;
using System.Text;
using System.Security.Cryptography;
using System.IO;

namespace EncrypDecryp
{
    public static class CifrarCadena
    {	
    	 public static string Encrypt(string   texto,
                                 	  string   passW,
                                 	  string   saltValue,
                                      string   hashAlgorithm,
                                      int      passwordIterations,
                                      string   initVector,
                                      int      keySize)
    		{
	        	byte[] initVectorBytes = Encoding.ASCII.GetBytes(initVector);
	        	byte[] saltValueBytes  = Encoding.ASCII.GetBytes(saltValue);
	        
	        	byte[] textoBytes  = Encoding.UTF8.GetBytes(texto);
	        
	        	PasswordDeriveBytes password = new PasswordDeriveBytes(
	                                                        			passW, 
	                                                        			saltValueBytes, 
	                                                        			hashAlgorithm, 
	                                                        			passwordIterations);
	        
	        	byte[] keyBytes = password.GetBytes(keySize / 8);
	        
	        	RijndaelManaged symmetricKey = new RijndaelManaged();
	       
	        	symmetricKey.Mode = CipherMode.CBC;        
	      
	        	ICryptoTransform encryptor = symmetricKey.CreateEncryptor(
	                                                         				keyBytes, 
	                                                         				initVectorBytes);
	        
	       
	        	MemoryStream memoryStream = new MemoryStream();        
	                
	        
	        	CryptoStream cryptoStream = new CryptoStream(memoryStream, 
	                                                     	 encryptor,
	                                                    	 CryptoStreamMode.Write);
	       
	        	cryptoStream.Write(textoBytes, 0, textoBytes.Length);
	                
	        
	        	cryptoStream.FlushFinalBlock();
	
	        	byte[] cipherTextBytes = memoryStream.ToArray();
	                
	        	memoryStream.Close();
	        	cryptoStream.Close();
	        
	        	string cipherText = Convert.ToBase64String(cipherTextBytes);
	        
	        	return cipherText;
    		}
    
	    	public static string Decrypt(string   cipherText,
		                                 string   passW,
		                                 string   saltValue,
		                                 string   hashAlgorithm,
		                                 int      passwordIterations,
		                                 string   initVector,
		                                 int      keySize)
    		{
       
    			string texto = "";
    			
		        byte[] initVectorBytes = Encoding.ASCII.GetBytes(initVector);
		        byte[] saltValueBytes  = Encoding.ASCII.GetBytes(saltValue);
		        
		        
		        byte[] cipherTextBytes = Convert.FromBase64String(cipherText);
		        
		        PasswordDeriveBytes password = new PasswordDeriveBytes(
				                                                        passW, 
				                                                        saltValueBytes, 
				                                                        hashAlgorithm, 
				                                                        passwordIterations);
		        
		        byte[] keyBytes = password.GetBytes(keySize / 8);
		        
		        RijndaelManaged    symmetricKey = new RijndaelManaged();
		       
		        symmetricKey.Mode = CipherMode.CBC;
		        
		     
		        ICryptoTransform decryptor = symmetricKey.CreateDecryptor(
					                                                         keyBytes, 
					                                                         initVectorBytes);
		       
		        MemoryStream  memoryStream = new MemoryStream(cipherTextBytes);
		        
		        CryptoStream  cryptoStream = new CryptoStream(memoryStream, 
		                                                      decryptor,
		                                                      CryptoStreamMode.Read);
		
		        try
		        {
			        byte[] textoBytes = new byte[cipherTextBytes.Length];
			        	
			       
			        int decryptedByteCount = cryptoStream.Read(textoBytes, 
			                                                   0, 
			                                                   textoBytes.Length);
			        
			        memoryStream.Close();
			        cryptoStream.Close();
			        
			        texto = Encoding.UTF8.GetString(textoBytes, 
			                                                   0, 
			                                                   decryptedByteCount);
		        }
		        
		        catch
		        {
		        	texto = "Usuario o clave incorrecta...";
		        }
		       
		        return texto;
    	}
	}
}
